import axios, { AxiosInstance } from 'axios';
import { boot } from 'quasar/wrappers';
import { Token, UserStateInterface } from 'src/plugins/user/store/user';
import config from '../config';

declare module 'vue/types/vue' {
  interface Vue {
    $axios: AxiosInstance;
  }
}

export default boot(({ Vue, store }) => {
  // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
  Vue.prototype.$axios = axios;
  axios.defaults.baseURL = config.baseURL;

  axios.interceptors.request.use(config => {
    // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access,@typescript-eslint/no-unsafe-assignment
    const token: Token = store.getters['user/token'];
    if (token) {
      // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
      config.headers['Token'] = token.token;
      //config.headers['Authorization'] = 'Token ' + token.token;
    }
    return config;
  });
});

export { axios };
